/* Define keyframes. */
@keyframes chat-popup-show {
  0% { bottom: 15px; }
  20% { bottom: 35px; }
  100% { bottom: 15px; }
}

@keyframes chat-popup-quick-hide {
  0% { opacity: 1; transform: translateY(0); }
  100% { opacity: 0; transform: translateY(100%); }
}

@keyframes chat-popup-hide {
  0% { opacity: 1; transform: translateY(0); }
  90% { opacity: 1; transform: translateY(0); }
  100% { opacity: 0; transform: translateY(100%); }
}

/* Utility styles. */
.visually-hidden {
  /* https://snook.ca/archives/html_and_css/hiding-content-for-accessibility */
  position: absolute !important;
  height: 1px;
  width: 1px;
  overflow: hidden;
  clip: rect(1px 1px 1px 1px);
  /* IE6, IE7 */
  clip: rect(1px, 1px, 1px, 1px);
}

.mod-hide {
  display: none !important;
}

/* Popup styling. */
#chat-popups {
  position: fixed;
  bottom: 15px;
  left: 15px;
  z-index: 45;
  /* background: white; */
  border-radius: 6px;
  /* padding: 10px; */
  margin: 0;
  /* box-shadow: 0px 0px 20px rgba(0,0,0,0.5); */
}
/* Apply animations. */
#chat-popups.chat-show {
  animation: chat-popup-show 0.35s ease-in-out,
    chat-popup-hide 5s ease-in-out;
  animation-fill-mode: forwards;
}
#chat-popups.chat-hide {
  animation: chat-popup-quick-hide 0.25s ease-in-out;
  animation-fill-mode: forwards;
}
#chat-popups.chat-empty {
  display: none;
}
/* Close button. */
#chat-popups .chat-close {
  color: black;
  position: absolute;
  top: 0;
  right: -28px;
  background: white;
  width: 22px;
  height: 22px;
  text-align: center;
  line-height: 1;
  display: flex;
  align-items: center;
  justify-content: center;
  border-radius: 50%;
  box-shadow: 0px 0px 20px rgba(0,0,0,0.5);
}
/* Recreate chat log styling. */
#chat-popups .chat-log {
  flex: 1;
  height: calc(100% - 140px);
  width: 300px;
  max-height: 60vh;
  margin-bottom: 10px;
  overflow-y: scroll;
}
#chat-popups .chat-messages {
  list-style: none;
  margin: 0;
  padding: 0;
}
#chat-popups .chat-messages .message {
  background: white;
  border: 1px solid #ddd;
  border-radius: 5px;
  margin: 3px;
  padding: 5px;
  color: #111;
  font-size: 10px;
  box-shadow: 0 0 2px #FFF inset;
}
#chat-popups .chat-messages .message .message-header h4 {
  margin-bottom: 0;
}
#chat-popups .chat-messages .message .message-header h3 {
  line-height: 24px;
  margin: 0;
}
#chat-popups .chat-messages .message .message-header .message-sender {
  flex: 3;
}
#chat-popups .chat-messages .message .message-header .message-metadata {
  text-align: right;
  line-height: 24px;
  color: #333;
  font-size: 12px;
}
#chat-popups .chat-messages .message.ic .message-content {
  font-style: italic;
}
/* Hide unused stuff.*/
#chat-popups .message button,
#chat-popups .message .button,
#chat-popups .message .message-metadata {
  display: none;
}
/* Overflow fixes for dialogs. */
/* .window-app.mod-short .window-content,
.app.sidebar-popout .window-content {
  max-height: 80vh;
  overflow-y: auto;
}
.window-app.mod-short {
  top: 10% !important;
}
.window-app.mod-short .window-content {
  display: block;
}
.window-app.mod-short .window-content .inventory-list {
  height: auto;
} */
/* Filepicker. */
.filepicker .file-directory {
  max-height: 40vh;
}

/* Hide theatre bar. */
#theatre-bar {
  opacity: 0 !important;
}